#include "main_gui.h"

#include <QPainter>

#define	BUFSIZE	2048

//int tmpSock;
char buf[BUFSIZE];
FILE *fp;

/* ------------------------------------------------------------------------- *
 * Constructor & Destructor
 * ------------------------------------------------------------------------- */

MobileWnd::MobileWnd(QWidget *parent) : QMainWindow(parent)
{
	setupUi(this);
	customizeUi();
	registerSignals();
}



/* ------------------------------------------------------------------------- *
 * Public Member Functions
 * ------------------------------------------------------------------------- */

void MobileWnd::paintEvent(QPaintEvent *event)
{
	QPainter painter(this);
	painter.eraseRect( event->rect() );
}

int MobileWnd::getSock()
{
	return sock;
}

/* ------------------------------------------------------------------------- *
 * Public Slots
 * ------------------------------------------------------------------------- */

void MobileWnd::mobile_play()
{

	sm_ip = qsm_addr->text().toAscii();
	printf( "SM : IP = %s\n", sm_ip );
	sm_port = qsm_port->text().toAscii();


	/* Session Manager address & port assignment. */
	memset( &sm_addr, 0, sizeof(sm_addr) );
	sm_addr.sin_family = AF_INET;
	sm_addr.sin_addr.s_addr = inet_addr(sm_ip);
	sm_addr.sin_port = htons(atoi(sm_port));

	/* MMCP API - mmcp_join() */
	mmcp_join( msd, sock, 
			(struct sockaddr_storage *) &sm_addr,
			(struct sockaddr_storage *) &group_addr );

	memset( &local_addr, 0, sizeof(local_addr) );
	local_addr.sin_family = AF_INET;
	local_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	local_addr.sin_port = group_addr.sin_port;

	if( bind(sock, (struct sockaddr *) &local_addr, sizeof(local_addr)) < 0 )
		err_print( "bind() error" );

	join_addr.imr_multiaddr.s_addr = group_addr.sin_addr.s_addr;
	join_addr.imr_interface.s_addr = htonl(INADDR_ANY);

	str = inet_ntoa(join_addr.imr_multiaddr);
	printf( "join: %s\n", str );
	str = inet_ntoa(group_addr.sin_addr);
	printf( "group: %s\n", str );

	state = setsockopt( sock, IPPROTO_IP, IP_ADD_MEMBERSHIP,
						(void*) &join_addr, sizeof(join_addr) );

	if( state )
		err_print( "setsockopt() error" );

	if( !(fp = fopen( "result.ts", "w" )) )
		err_print( "Open() error" );

	printf( "create..... result.ts\n" );
	printf( "main sock num = %d\n", sock );

	recvData->start();


	usleep(2000);
	if ( currentContent != "" ) {

		// Change player size
		QRect s = page_client->frameGeometry();

//		qDebug("StvWnd::play:");
//		qDebug("\\______ frameMPlayer->frameRect(): %dx%d+%d+%d",
//				s.width(), s.height(), s.x(), s.y());

		QString options = "";

		options += "mplayer -vo x11";
		options += " -geometry 100%:100%";
//		options += " -zoom";
		options += " -wid " + QString::number(frameMPlayer->winId());
		options += " -slave -idle";
		options += " -fs " + currentContent;
		mplayer->start(options);
		
		const char* sm_tmp;
		sm_tmp = options.toAscii();
		printf( "%s\n", sm_tmp );
	}
}


/* ------------------------------------------------------------------------- *
 * Private Member Functions
 * ------------------------------------------------------------------------- */

void MobileWnd::err_print( char *msg )
{
	perror(msg);
	exit(1);
}

void MobileWnd::customizeUi()
{
	/* MMCP API - mmcp_socket() */
	msd = mmcp_socket( PF_INET, IPPROTO_UDP, MMCP_ROLE_MN );
	if( msd < 0 )
		err_print( "mmcp_socket() error:" );

	printf( "msd = %d\n", msd );

	sock = socket( PF_INET, SOCK_DGRAM, IPPROTO_UDP );
	if( sock == -1 )
		err_print( "socket() error:" );

	// Create Embedded Container for MPlayer.
	mplayer = new QProcess(page_client);
	mplayer->setProcessChannelMode(QProcess::MergedChannels);

	recvData = new recvThread(this, sock);

	// Set currentContent string.
	currentContent = "result.ts";
}

void MobileWnd::registerSignals()
{
	// Register signal for PushButtions.
	
	QObject::connect( pb_play, SIGNAL(clicked()), this, SLOT(mobile_play()) );
}


/* ------------------------------------------------------------------------- *
 * recvThread : public QThread
 * ------------------------------------------------------------------------- */

void recvThread::run()
{
	ssize_t nbytes;
	int i=0;

	printf( "read start!: %d\n", recv_sock );

	if( recv_sock > 0 ) {
		
		while(1) {
//			i++;
			nbytes = recvfrom( recv_sock, buf, BUFSIZE, 0, NULL, NULL );
//			printf( "nbytes = %d, i = %d\n", nbytes, i );
			if( nbytes <= 0 )
				break;

			buf[nbytes] = 0;

			nbytes = fwrite( buf, 1, nbytes, fp );
//			printf( "fwrite = %d\n", nbytes );
		}

	}
}
