#ifndef	_MMCP_GUI_H
#define	_MMCP_GUI_H

////////////////////////////////////////

#include <QPointer>
#include <QProcess>
#include <QX11EmbedContainer>
#include <QDesktopWidget>
#include <QResizeEvent>
#include <QPaintEvent>

#include <QThread>

////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netinet/in.h>

#include <mmcp.h>

#include "ui_mobile_form.h"

////////////////////////////////////////



class MobileWnd : public QMainWindow, protected Ui::MainWindow {

	Q_OBJECT

public:

	//! Constructor
	MobileWnd(QWidget *parent = 0);

	int getSock();

public slots:
	void mobile_play();

protected:

	QX11EmbedContainer *mplayerContainer;
	QPointer<QProcess> mplayer;

	QThread *recvData;
	QString currentContent;

	virtual void paintEvent(QPaintEvent *event);

private:
	int sock, msd;
	int state;
	struct sockaddr_in local_addr;
	struct sockaddr_in sm_addr;
	struct sockaddr_in group_addr;

	struct ip_mreq join_addr;
	char *str;

	const char *local_ip;
	const char *sm_ip;
	const char *group_ip;
	const char *sm_port;

	void err_print( char *msg );
	void customizeUi(void);
	void registerSignals(void);
};

class recvThread : public QThread
{
public:
	recvThread( QObject *parent = 0, int msock = 0 ) {
		owner = parent;
		recv_sock = msock;
	}

	void run();

private:
	int recv_sock;
	QObject *owner;
};

#endif
