#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>
#include <errno.h>

#include <mmcp.h>

void err_print( char *msg );

int main( int argc, char** argv )
{
	int msd;
	struct sockaddr_in local_addr;
	struct sockaddr_in sm_addr;

	if( argc != 4 ) {
		printf( "Usage: %s [LOCAL ADDR] [SM ADDR] [1 or 2]\n", argv[0] );
		exit(1);
	}

	printf( "This program is Local Mobility Controller.\n" );

	msd = mmcp_socket( PF_INET, IPPROTO_UDP, MMCP_ROLE_LMC );
	if( msd < 0 )
		err_print( "mmcp_socket() error:" );

	printf( "msd = %d\n", msd );

	memset( &local_addr, 0, sizeof(local_addr) );
	local_addr.sin_family = AF_INET;
	local_addr.sin_addr.s_addr = inet_addr(argv[1]);
	local_addr.sin_port = htons(atoi(argv[3]));

	memset( &sm_addr, 0, sizeof(sm_addr) );
	sm_addr.sin_family = AF_INET;
	sm_addr.sin_addr.s_addr = inet_addr(argv[2]);
	sm_addr.sin_port = htons(MMCP_SM_PORT);

	mmcp_lmc_join( msd, (struct sockaddr_storage *) &local_addr,
				(struct sockaddr_storage *) &sm_addr );

	return 0;
}

void err_print( char *msg )
{
	perror(msg);
	exit(1);
}
