#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>
#include <errno.h>

#include <mmcp.h>

void err_print( char *msg );

int main( int argc, char** argv )
{
	int msd;
	struct sockaddr_in local_addr;
	struct sockaddr_in mcs_addr;

	if( argc != 4 ) {
		printf( "Usage: %s [SM ADDR] [GROUP ADDR] [GROUP PORT]\n", argv[0] );
		exit(0);
	}

	printf( "This program is Session Manager.\n" );

	msd = mmcp_socket( PF_INET, IPPROTO_UDP, MMCP_ROLE_SM );
	if( msd < 0 )
		err_print( "mmcp_socket() error:" );

	printf( "msd = %d\n", msd );

	memset( &local_addr, 0, sizeof(local_addr) );
	local_addr.sin_family = AF_INET;
	local_addr.sin_addr.s_addr = inet_addr(argv[1]);
	local_addr.sin_port = htons(MMCP_SM_PORT);

	memset( &mcs_addr, 0, sizeof(mcs_addr) );
	mcs_addr.sin_family = AF_INET;
	mcs_addr.sin_addr.s_addr = inet_addr(argv[2]);
	mcs_addr.sin_port = htons(atoi(argv[3]));

	if( mmcp_create(msd, (struct sockaddr_storage *) &local_addr, 
				(struct sockaddr_storage *) &mcs_addr) < 0 )
		err_print( "mmcp_create() error:" );

	mmcp_processing( msd );


	return 0;
}

void err_print( char *msg )
{
	perror(msg);
	exit(1);
}
