#include <header/structs.h>

#include <sys/types.h>

#define IEEE802_11_FC_LEN	2

#define T_MGMT 		0x0	/* FC type : management */
#define ST_BEACON  	0x8	/* FC sub-type : BEACON */

/* Bits in the frame control field. */
#define FC_TYPE(fc)			(((fc) >> 2) & 0x3)
#define FC_SUBTYPE(fc)		(((fc) >> 4) & 0xF)

struct mgmt_header_t {
	u_int16_t	fc;
	u_int16_t 	duration;
	u_int8_t	da[6];
	u_int8_t	sa[6];
	u_int8_t	bssid[6];
	u_int16_t	seq_ctrl;
};

#define MGMT_HEADER_LEN	(2+2+6+6+6+2)

struct ssid_t {
	u_int8_t	element_id;
	u_int8_t	length;
	char		ssid[33];  /* 32 + 1 for null */
} ;

#define E_SSID 		0

struct mgmt_body_t {
	u_int16_t 	aid;
	u_char		ap[6];
	struct ssid_t	ssid;
};

#define EXTRACT_16BITS(p) \
	((u_int16_t)ntohs(*(const u_int16_t *)(p)))
#define EXTRACT_32BITS(p) \
	((u_int32_t)ntohl(*(const u_int32_t *)(p)))

/* Little endian protocol host order macros */

#define EXTRACT_LE_8BITS(p) (*(p))
#define EXTRACT_LE_16BITS(p) \
	((u_int16_t)*((const u_int8_t *)(p) + 1) << 8 | \
	(u_int16_t)*((const u_int8_t *)(p) + 0))


extern void wlan_ieee80211_capture( struct mmcp_socket *mso, char *device );
