/*	Mobile Multicast Control Protocol Implementation.
 *
 *	This file is part of the MMCP over UDP Implementation.
 *
 *	user.h
 *	This header includes API of MMCP.
 *
 *	Contant :	Jaesung Park(knucsid@gmail.com)
 *				Jiin Kim
 */

#ifndef	_MMCP_USER_H
#define	_MMCP_USER_H

#ifdef	__cplusplus
extern "C" {
#endif

/* ----------------------------------------------------------------- *
 *	MMCP Socket APIs Def.
 * ----------------------------------------------------------------- */

// internal - socket()
extern int mmcp_socket( int domain, int protocol, int role );

// internal - bind()
extern int mmcp_create( int msd, struct sockaddr_storage *local_addr, 
						struct sockaddr_storage *group_addr );

// MN
//extern int mmcp_join( int msd, int usd, struct sockaddr_storage *local_addr,
extern int mmcp_join( int msd, int usd,
	struct sockaddr_storage *upper_addr, struct sockaddr_storage *mcs_addr );

extern int mmcp_lmc_join( int msd, struct sockaddr_storage *local_addr,
						struct sockaddr_storage *upper_addr );

extern void mmcp_processing( int msd );

extern int mmcp_leave( int msd );

extern int mmcp_setsockopt( int msd, int level, int optname,
							void *optval, socklen_t optlen );

extern int mmcp_getsockopt( int msd, int level, int optname,
							void *optval, socklen_t *optlen );

// print screen - LMC or SM
extern int mmcp_status_monitor();

// knucsid 080227 - test handover(remove)
extern int mmcp_test_handover( int msd );

#ifdef	__cplusplus
}
#endif

#endif	/* _MMCP_USER_H */
