/*	Mobile Multicast Control Protocol Implementation.
 *
 *	This file is part of the MMCP over UDP Implementation.
 *
 *	mmcp.h
 *	This header is used to the MMCP by user.
 *
 *	Contact :	Jaesung Park (knucsid@gmail.com)
 *				Jiin Kim
 */

#ifndef	_MMCP_H
#define	_MMCP_H

/* ----------------------------------------------------------------- *
 *	Header Files Included 
 * ----------------------------------------------------------------- */

#include <sys/types.h>
#include <sys/socket.h>


#ifdef	__cplusplus
extern "C" {
#endif

#define	MMCP_SM_PORT			8585
#define	MMCP_LMC_PORT_ONE		9926
#define	MMCP_LMC_PORT_TWO		9939
#define	MMCP_MN_PORT			9859

/* ----------------------------------------------------------------- *
 *	MMCP Role 
 * ----------------------------------------------------------------- */

typedef enum
{
	MMCP_ROLE_NONE	= 0,
#define MMCP_ROLE_NONE		MMCP_ROLE_NONE

	MMCP_ROLE_SM,
#define MMCP_ROLE_SM		MMCP_ROLE_SM

	MMCP_ROLE_LMC,
#define MMCP_ROLE_LMC		MMCP_ROLE_LMC

	MMCP_ROLE_MN
#define	MMCP_ROLE_MN		MMCP_ROLE_MN

} mmcp_role_t;


/* ----------------------------------------------------------------- *
 *	MMCP Socket APIs Def. 
 * ----------------------------------------------------------------- */

extern int mmcp_socket( int domain, int protocol, int role );

extern int mmcp_create( int msd, struct sockaddr_storage *local_addr, 
						struct sockaddr_storage *group_addr );

//extern int mmcp_join( int msd, int usd, struct sockaddr_storage *local_addr,
extern int mmcp_join( int msd, int usd, 
	struct sockaddr_storage *upper_addr, struct sockaddr_storage *mcs_addr );

extern int mmcp_lmc_join( int msd, struct sockaddr_storage *local_addr,
						struct sockaddr_storage *upper_addr );

extern void mmcp_processing(int msd );

extern int mmcp_leave( int msd );

extern int mmcp_setsockopt( int msd, int level, int optname,
							void *optval, socklen_t optlen );

extern int mmcp_getsockopt( int msd, int level, int optname,
							void *optval, socklen_t *optlen );

extern int mmcp_status_monitor();

extern int mmcp_test_handover( int msd );



#ifdef	__cplusplus
}
#endif

#endif	/* _MMCP_H */
